---
title: Firefox 49 for developers
slug: Mozilla/Firefox/Releases/49
tags:
  - Firefox
  - Release Notes
---
<div>{{FirefoxSidebar}}</div>

<p><a href="https://www.mozilla.org/firefox/developer/" style="float: right; margin-bottom: 20px; padding: 10px; text-align: center; border-radius: 4px; display: inline-block; background-color: #81BC2E; white-space: nowrap; color: white; text-shadow: 0px 1px 0px rgba(0, 0, 0, 0.25); box-shadow: 0px 1px 0px 0px rgba(0, 0, 0, 0.2), 0px -1px 0px 0px rgba(0, 0, 0, 0.3) inset;">To test the latest developer features of Firefox,<br>
 install Firefox Developer Edition</a> Firefox 49 was released on September 20, 2016. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li>JavaScript errors logged into the console <a href="https://hacks.mozilla.org/2016/06/helping-web-developers-with-javascript-errors/">now provide a [Learn more] link</a> for additional debugging help ({{bug(1179876)}}).</li>
 <li>CSS autocomplete: show more suggestions in autocomplete popup ({{bug("1260419")}}).</li>
 <li>The Animation Inspector now <a href="/en-US/docs/Tools/Page_Inspector/How_to/Work_with_animations#Further_information_about_animation_compositing">exposes animation performance information</a> in DevTools ({{bug("1254408")}}).</li>
 <li>The <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_HTML#Element_popup_context_menu">Inspector's context menu</a> has been reorganized to be cleaner and easier to use ({{bug("1211613")}}).</li>
 <li>The Inspector now supports <code>#RRGGBBAA</code> and <code>#RGBA</code> syntax for color values ({{bug("1271191")}}).</li>
 <li>The developer tools no longer display self-closing tags (such as {{HTMLElement("br")}} and {{HTMLElement("img")}} as if they have a closing tag on HTML pages; the behavior is unchanged for XHTML pages ({{bug("820926")}}).</li>
 <li>Accessibility improvements!
  <ul>
   <li>The toolbox does a better job of ensuring that keyboard focus is more visible ({{bug(1242851)}}).</li>
   <li>Accessibility labels have been added to unlabeled controls ({{bug(1242715)}}).</li>
   <li>Added proper tree view semantics and keyboard navigation to the Inspector's markup view ({{bug(1242694)}}).</li>
  </ul>
 </li>
 <li>The <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> now shows a Cause column, which provides an indication of what caused each particular network request ({{bug(1134073)}}).</li>
 <li>In the <em>about:debugging</em> Add-ons page, the Reload button is only enabled for temporary add-ons. It will be disabled for all other add-ons ({{bug(1273184)}}).</li>
 <li>In the <em>about:debugging</em> Workers page, a warning message will be displayed in the Service Workers section if <a href="/en-US/docs/Tools/about:debugging#Service_workers_not_compatible">service workers are incompatible</a> with the current browser configuration ({{bug(1266415)}}).</li>
 <li><em>about:debugging</em> now has a <a href="/en-US/docs/Tools/about:debugging#Tabs">new Tabs page</a> available, which provides a complete list of all the debuggable tabs open in the current Firefox instance ({{bug(1266128)}}).</li>
 <li>The <em>Disable Cache</em> option in the <a href="/en-US/docs/Tools/Settings#Advanced_settings">Toolbox Advanced settings</a> has been renamed to Disable HTTP Cache, to make it clearer that this affects the HTTP cache, and not <a href="/en-US/docs/Web/API/Service_Worker_API">Service Workers</a>/the <a href="/en-US/docs/Web/API/Cache">Cache API</a> (bug(1253018)).</li>
 <li>The <a href="/en-US/docs/Tools/Storage_Inspector#IndexedDB">Storage Inspector now allows IndexedDB databases to be deleted</a> via their own context menus ({{bug("1205123")}}), and will display warning messages if the IndexedDB cannot be deleted for some reason (if there are still active connections, for example) ({{bug(1268460)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Added support for the {{HTMLElement("details")}} and {{HTMLElement("summary")}} elements ({{bug(1226455)}}).</li>
 <li>The {{htmlattrxref("pattern", "input")}} attribute of the {{HTMLElement("input")}} element now uses the <code>'u'</code> parameter in the underlying JavaScript {{jsxref("RegExp")}} ({{bug(1227906)}}).</li>
 <li>To match a spec change, an invalid value of the {{htmlattrxref("kind", "track")}} attribute of the {{HTMLElement('track')}} element is now treated like <code>"metadata"</code> instead of <code>"subtitles"</code> ({{bug(1269712)}}).</li>
 <li>The {{HTMLElement("iframe")}} element's {{htmlattrxref("sandbox", "iframe")}} attribute now supports the <code>'allow-popups-to-escape-sandbox'</code> and <code>'allow-modals'</code> values ({{bug(1190641)}}).</li>
 <li>Support for microdata attributes and the Microdata API have been removed ({{bug(909633)}}).</li>
 <li>The {{htmlattrxref("referrerpolicy", "a")}} attribute on the {{HTMLElement("a")}} element now supports the <code>'no-referrer-when-downgrade</code>' and <code>'origin-when-cross-origin'</code> ({{bug(1178337)}}).</li>
 <li>The {{htmlattrxref("form", "label")}} content attribute of the {{HTMLElement("label")}} element has been removed. The {{domxref("HTMLLabelElement.form")}} property still exists, but now returns the form with which the label's control is associated, if there is a control (and if that control is associated with a form) ({{bug(1268852)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Added {{cssxref("background-position-x")}} and {{cssxref("background-position-y")}}, which allow separately specifying the horizontal and vertical offsets at which to draw a background image; these are components of {{cssxref("background-position")}} ({{bug("550426")}}).</li>
 <li>Added support for the <code>round</code> and <code>space</code> keywords to {{cssxref("background-repeat")}} ({{bug("548372")}}).</li>
 <li>On {{cssxref("background-clip")}}, the keyword <code>text</code> is now activated by default ({{bug(1264905)}}).</li>
 <li>Added support for specifying colors with an alpha channel using 4- and 8-digit CSS hex <a href="/en-US/docs/Web/CSS/color_value">color</a> values (#RRGGBBAA and #RGBA) ({{bug("567283")}}).</li>
 <li>The pseudo-class {{cssxref(":dir()")}} has been unprefixed ({{bug(859301)}}).</li>
 <li>In our experimental implementation (not yet activated by default) of {{cssxref("clip-path")}}, we can now interpolate between {{cssxref("&lt;basic-shape&gt;")}} values ({{bug(1110460)}}).</li>
 <li>Added the <a href="/en-US/docs/Web/CSS/length#q"><code>q</code> length unit</a> ({{bug(1274526)}}).</li>
 <li>The property {{cssxref("text-align-last")}} has been unprefixed ({{bug(1039541)}}).</li>
 <li>Added support for {{cssxref("overflow-wrap")}}, replacing {{cssxref("word-wrap")}} that is still supported as an alternative name ({{bug(955857)}}).</li>
 <li>Our experimental <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grids</a> implementation has been improved:
  <ul>
   <li>Implemented {{cssxref("&lt;percentage&gt;")}} for the {{cssxref("grid-gap")}}, {{cssxref("grid-row-gap")}}, and {{cssxref("grid-column-gap")}} properties ({{bug(1266268)}}).</li>
   <li>Implemented grid layout support for {{cssxref("align")}}, {{cssxref("justify-self")}}<code>:baseline</code> and <code>last-baseline</code> (aka "baseline self-alignment") ({{bug(1221525)}}).</li>
   <li>Implemented grid item baseline content alignment ({{bug(1256429)}}).</li>
  </ul>
 </li>
 <li>Our experimental <a href="/en-US/docs/Web/CSS/CSS_Masks">CSS Masks</a> implementation has been improved:
  <ul>
   <li>The {{cssxref("mask-origin")}} property now uses <code>border-box</code> instead of <code>padding-box</code> as initial value, to match the spec ({{bug(1258286)}}).</li>
   <li>The {{cssxref("mask-repeat")}} property now supports the <code>space</code> and <code>round</code> values ({{bug(1258626)}}).</li>
   <li>Fixed an issue preventing the {{cssxref("mask-position")}} attribute from being animated ({{bug(1273804)}}).</li>
  </ul>
 </li>
 <li>The preference controlling {{cssxref("text-emphasis")}} has been removed, so support for this property can no longer be disabled ({{bug(1229609)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The ES2015 {{jsxref("Global_Objects/Proxy/handler/getPrototypeOf", "getPrototypeOf()")}} and {{jsxref("Global_Objects/Proxy/handler/setPrototypeOf", "setPrototypeOf()")}} {{jsxref("Proxy")}} traps have been implemented ({{bug(888969)}}).</li>
 <li>The ES2015 {{jsxref("RegExp.prototype.@@match()", "RegExp.prototype[@@match]()")}}, {{jsxref("RegExp.prototype.@@replace()", "RegExp.prototype[@@replace]()")}}, {{jsxref("RegExp.prototype.@@search()", "RegExp.prototype[@@search]()")}}, and {{jsxref("RegExp.prototype.@@split()", "RegExp.prototype[@@split]()")}} methods, and {{jsxref("RegExp.@@species", "RegExp[@@species]")}} getter have been implemented ({{bug(887016)}}).</li>
 <li>The deprecated, non-standard <code>flags</code> argument of <code>String.prototype.</code>{{jsxref("String.prototype.match", "match")}}/{{jsxref("String.prototype.search", "search")}}/{{jsxref("String.prototype.replace", "replace")}} has been removed ({{bug(1108382)}}).</li>
 <li>The behavior of the {{jsxref("Date.parse()")}} method when parsing 2-digit years has been changed to be more interoperable with the Google Chrome browser ({{bug(1265136)}}).</li>
</ul>

<h3 id="InterfacesAPIsDOM">Interfaces/APIs/DOM</h3>

<h4 id="DOM_HTML_DOM">DOM &amp; HTML DOM</h4>

<ul>
 <li>The method {{domxref("DOMTokenList.supports()")}} has been added ({{bug(1257849)}}).</li>
 <li>The {{domxref("DOMTokenList.replace()")}} method has been added ({{bug(1224186)}}).</li>
 <li>Leading <code>'?'</code> characters are now ignored in the parameter of the {{domxref("URLSearchParams.URLSearchParams", "URLSearchParams()")}} constructor ({{bug(1268361)}}).</li>
 <li>The value returned by {{domxref("URL.origin")}}, {{domxref("HTMLAnchorElement.origin")}}, and {{domxref("HTMLAreaElement.origin")}} for URL using the <code>blob:</code> scheme is no longer incorrectly <code>null</code> but is instead the origin of the URL formed by removing the leading <code>blob:</code> ({{bug(1270451)}}).</li>
 <li>In prerendering mode, the {{domxref('Document.visibilityState')}} property now returns <code>'prerender'</code> ({{bug(1069772)}}).</li>
 <li>The {{domxref("Window.isSecureContext")}} property has been implemented ({{bug(1162772)}}).</li>
 <li>The DOM4 {{domxref("ChildNode.before()")}}, {{domxref("ChildNode.after()")}}, {{domxref("ChildNode.replaceWith()")}}, {{domxref("ParentNode.append()")}} and {{domxref("ParentNode.prepend()")}} methods have been implemented ({{bug(911477)}}).</li>
 <li>The {{domxref("TouchList.identifiedTouch()")}} method has been removed ({{bug(1188539)}}).</li>
 <li>By default, the <code>scrollbars</code> {{domxref("Window")}} feature is enabled when calling {{domxref("Window.open()")}}. In the past, while it was strongly recommended to enable it, it wasn't the default ({{bug(1257887)}}).</li>
 <li>Added the <em>experimental</em> and <em>non-standard</em> {{domxref("HTMLMediaElement.seekToNextFrame()")}} method, which allows seeking frame-by-frame through video content ({{bug(1235301)}}). While you're encouraged to experiment with this method to help us understand how useful it is, <em>do not use it in production code!</em></li>
 <li>The {{domxref("HTMLLabelElement.form")}} property now returns the form with which the label's control is associated, if there is a control (and if that control is associated with a form). Previously, labels were directly associated with forms using this property ({{bug(1268852)}}).</li>
 <li>Support for the third parameter of {{domxref("EventTarget.addEventListener()")}}, either a {{jsxref("Boolean")}} or an {{interface("EventListenerOptions")}} has been added ({{bug(1266164)}} and {{bug(1266066)}}).</li>
 <li>The audio volume related values for {{domxref("KeyboardEvent.key")}} have been renamed. <code>"VolumeDown"</code> is now <code>"AudioVolumeDown"</code>, <code>"VolumeUp"</code> is now <code>"AudioVolumeUp"</code>, and <code>"VolumeMute"</code> is now <code>"AudioVolumeMute".</code> This brings Firefox into alignment with the latest draft of the UI Events specification ({{bug(1272578)}}). See {{SectionOnPage("/en-US/docs/Web/API/KeyboardEvent/code", "Code values")}} for a full list of available key codes.</li>
 <li>The keys previously referred to as <code>"MozHomeScreen"</code>, <code>"MozCameraFocusAdjust"</code>, and <code>"MozPhoneCall"</code> now have official names in the UI Events specification: <code>"GoHome"</code>, <code>"CameraFocus"</code>, and <code>"Call"</code>. Firefox 49 has been updated to use the new names ({{bug(1272599)}}). See {{SectionOnPage("/en-US/docs/Web/API/KeyboardEvent/code", "Code values")}} for a full list of available key codes.</li>
 <li>The key values <code>"Separator"</code> and <code>"MediaSkip"</code> have been removed, as they were deprecated and unused ({{bug(1232919)}}).</li>
 <li>Key values and the corresponding key codes <code>"Hyper"</code> and <code>"Super"</code> have been added to represent these legacy modifier keys ({{bug(1232919)}}).</li>
 <li>Two key values for multimedia numeric keypad keys have been added: <code>"Key11"</code> and <code>"Key12"</code> ({{bug(1232919)}}).</li>
 <li>The following new key values have been added for audio control keys: <code>"AudioBassBoostToggle"</code>, <code>"AudioTrebleDown"</code>, and <code>"AudioTrebleUp"</code> ({{bug(123919)}}).</li>
 <li>Key values have been added for these microphone control keys: <code>"</code><code>MicrophoneToggle"</code>, <code>"</code><code>MicrophoneVolumeDown"</code>, <code>"</code><code>MicrophoneVolumeUp"</code>, and <code>"</code><code>MicrophoneVolumeMute"</code> ({{bug(123919)}}).</li>
 <li>New key values have been added to support speech recognition devices: "<code>SpeechCorrectionList"</code> and <code>"</code><code>SpeechInputToggle"</code> ({{bug(1232919)}}).</li>
 <li>New key values have been added to support special buttons on phones: <code>"</code><code>AppSwitch"</code>, <code>"</code><code>Call"</code>, <code>"</code><code>CameraFocus"</code>, <code>"</code><code>EndCall"</code>, <code>"</code><code>GoBack"</code>, <code>"</code><code>GoHome"</code>, <code>"</code><code>HeadsetHook"</code>, <code>"</code><code>LastNumberRedial"</code>, <code>"</code><code>Notification"</code>, <code>"</code><code>MannerMode"</code>, and <code>"</code><code>VoiceDial"</code> ({{bug(1232919)}}).</li>
 <li>These new application key values have been added: <code>"</code><code>LaunchContacts"</code> and <code>"</code><code>LaunchPhone"</code> ({{bug(1232919)}}).</li>
 <li>New key values have been added to support television devices: <code>"</code><code>TV3DMode"</code>, <code>"</code><code>TVAntennaCable"</code>, <code>"</code><code>TVAudioDescription"</code>, <code>"</code><code>TVAudioDescriptionMixDown"</code>, <code>"</code><code>TVAudioDescriptionMixUp"</code>, <code>"</code><code>TVContentsMenu"</code>, <code>"</code><code>TVDataService"</code>, <code>"</code><code>TVInput"</code>, <code>"</code><code>TVInputComponent1"</code>, <code>"</code><code>TVInputComponent2"</code>, <code>"</code><code>TVInputComposite1"</code>, <code>"</code><code>TVInputComposite2"</code>, <code>"</code><code>TVInputHDMI1"</code>, <code>"</code><code>TVInputHDMI2"</code>, <code>"</code><code>TVInputHDMI3"</code>, <code>"</code><code>TVInputHDMI4"</code>, <code>"</code><code>TVInputVGA1"</code>, <code>"</code><code>TVMediaContext"</code>, <code>"</code><code>TVNetwork"</code>, <code>"</code><code>TVNumberEntry"</code>, <code>"</code><code>TVRadioService"</code>, <code>"</code><code>TVSatellite"</code>, <code>"</code><code>TVSatelliteBS"</code>, <code>"</code><code>TVSatelliteCS"</code>, <code>"</code><code>TVSatelliteToggle"</code>, <code>"</code><code>TVTerrestrialAnalog"</code>, <code>"</code><code>TVTerrestrialDigital"</code>, <code>"</code><code>TVTimer"</code>, and <code>"</code><code>DVR"</code> ({{bug(1232919)}}).</li>
 <li>The key value <code>"</code><code>MediaSelect"</code> has been replaced with the standard <code>"</code><code>LaunchMediaPlayer"</code> key value ({{bug(1272592)}}).</li>
 <li>Additional media player key values have been added as well. These are <code>"</code><code>MediaAudioTrack"</code>, <code>"</code><code>MediaSkipBackward"</code>, <code>"</code><code>MediaSkipForward"</code>, <code>"</code><code>MediaStepBackward"</code>, <code>"</code><code>MediaStepForward"</code>, <code>"</code><code>MediaTopMenu"</code>, <code>"</code><code>NavigateIn"</code>, <code>"</code><code>NavigateNext"</code>, <code>"</code><code>NavigateOut"</code>, and <code>"</code><code>NavigatePrevious"</code> ({{bug(1232919)}}).</li>
</ul>

<h4 id="Canvas">Canvas</h4>

<ul>
 <li>The {{domxref("CanvasRenderingContext2D.filter")}} property, which provides support for adding filters to a canvas, is now activated by default and no longer needs to be enabled using a preference ({{bug(1173545)}}).</li>
</ul>

<h4 id="WebGL">WebGL</h4>

<ul>
 <li>The {{domxref("EXT_color_buffer_float")}} {{domxref("WebGL2RenderingContext", "WebGL 2", "", 1)}} extension has been implemented ({{bug(1129332)}}).</li>
 <li>The {{Event("webglcontextcreationerror")}} event, which is sent when a WebGL context creation attempt fails, has been implemented ({{bug(1271478)}}). Use this to help understand what went wrong, both for debugging and for production error handling.</li>
</ul>

<h4 id="IndexedDB">IndexedDB</h4>

<ul>
 <li>You can now rename IndexedDB indexes; the {{domxref("IDBIndex.name")}} property is no longer read-only ({{bug(1118028)}}).</li>
 <li>You can also now rename {{domxref("IDBObjectStore")}}s; the {{domxref("IDBObjectStore.name")}} property is no longer read-only ({{bug(1118028)}}).</li>
</ul>

<h4 id="Service_Workers_and_related">Service Workers and related</h4>

<ul>
 <li>The <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a>'s {{domxref("Response")}} object now implements the {{domxref("Response.redirected", "redirected")}} property, which indicates whether or not the response is for a request which was redirected. Please review the security related notes in the documentation before using this property ({{bug(1243792)}}).</li>
 <li>In the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a>, Firefox no longer supports the 'push' <code>PermissionDescriptor</code> dictionary type (referred to in the spec as <code>PushPermissionDescriptor</code>); this is because Firefox relies on a quota system for controlling the <code>userVisibleOnly</code> status instead, and was throwing an error when it encountered a <code>PushPermissionDescriptor</code> instance ({{bug(1266821)}}). With this dictionary removed, Firefox now ignores it.</li>
</ul>

<h4 id="Media_Streams">Media Streams</h4>

<ul>
 <li>In the past, it was possible for a call to {{domxref("MediaDevices.getUserMedia()")}} which requests both audio and video to succeed in cases where the user has only one of the two types of hardware available. This has been fixed ({{bug(802326)}}).</li>
 <li>In prior versions of Firefox, it was possible for a call to {{domxref("MediaDevices.getUserMedia()")}} which requests both audio and video to succeed even though the user denied access to one but not both of the matching devices. This has been fixed ({{bug(802326)}}). This involves minor user interface changes as well, to remove the options to choose "No audio" or "No video" when the user is prompted for permissions.</li>
 <li>The {{domxref("MediaStream.getTrackById()")}} method has been implemented ({{bug(1208390)}}).</li>
</ul>

<h4 id="WebRTC">WebRTC</h4>

<ul>
 <li>The {{domxref("RTCPeerConnection.addTrack()")}} method has been updated to allow tracks which are not components of the specified streams to be added to the connection. Instead, the streams are used to group tracks on the receiving end of the connection ({{bug(1271669)}}).</li>
</ul>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>The {{domxref("PerformanceObserver")}} API is now activated by default on Nightly. It is not available by default in other versions of Firefox 49 ({{bug(1271487)}}).</li>
</ul>

<h4 id="Others">Others</h4>

<ul>
 <li>{{domxref("XMLHttpRequest.getResponseHeader()")}} and {{domxref("XMLHttpRequest.getAllResponseHeaders()")}} return empty headers in case the preference <code>network.http.keep_empty_response_headers_as_empty_string</code> is set to <code>true</code> ({{bug(669259)}}).</li>
 <li>The Firefox OS-only <a href="/en-US/docs/Archive/Firefox_OS/API/Data_Store_API">Data Store API</a> has been removed ({{bug(1261009)}}).</li>
 <li>The <a href="/en-US/docs/Web/API/Fullscreen_API">Fullscreen API</a> event handlers {{domxref("Document.onfullscreenchange")}} and {{domxref("Document.onfullscreenerror")}} have been removed from {{domxref("Element")}} as they were never fired there; the prefixed versions of these event handlers have been kept there for compatibility purposes, however ({{bug(1270386)}}). Note that this is not yet activated by default, but is behind the <code>full-screen-api.unprefix.enabled</code> preference ({{bug(1268749)}}).</li>
 <li>The obsolete {{domxref("Document.mozFullScreen")}} property has been unprefixed to {{domxref("Document.fullscreen")}} {{bug(1269157)}}}. Note that this is not yet activated by default by behind the <code>full-screen-api.unprefix.enabled</code> preference ({{bug(1268749)}}).</li>
 <li>The read-only properties {{domxref("Document.fullscreenElement")}} and {{domxref("Document.fullscreenEnabled")}} no longer throw an exception if an attempt is made to change their values; instead, the new value is silently ignored and the setter function is a no-op ({{bug(1269798)}}).</li>
 <li>Any kind of data can now be retrieved from the clipboard using {{domxref("DataTransfer.getData()")}}: previously, only data of certain MIME types were supported {{bug(860857)}}.</li>
 <li>Our implementation of the <a href="/en-US/docs/Web/API/Frame_Timing_API">Frame Timing API</a>, consisting of the two interfaces <code>PerformanceCompositeTiming</code> and <code>PerformanceRenderTiming</code>, has been removed as the spec has been completely rewritten ({{bug(1271846)}}).</li>
 <li>To match the spec, the {{domxref("VTTCue.positionAlign")}} property now returns a <code>PositionAlign</code> enum instead of an <code>Align</code> enum ({{bug(1276129)}}).</li>
 <li>The speech synthesis part of <a href="/en-US/docs/Web/API/Web_Speech_API#Speech_synthesis">Web Speech API</a> is now activated by default ({{bug(1268633)}}).</li>
 <li>The <a href="/en-US/docs/Web/API/Performance_Timeline">Performance Timeline API</a> is now available by default in Nightly (though not in Aurora, Beta or Release).</li>
 <li>The {{event("install")}} event, and the {{domxref("Window.oninstall")}} event handler, are now supported for <a href="/en-US/docs/Web/Manifest">Web Manifests</a> ({{bug(1265279)}}).</li>
 <li>When using the {{domxref("AudioContext.createPeriodicWave()")}} method of the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>, you can now specify whether the resulting periodic wave should be normalized by including a dictionary object as the third parameter, which includes a single parameter — <code>{disableNormalization: true}</code> ({{bug(1265405)}}).</li>
 <li>In the WebVTT API, {{domxref("VTTCue.positionAlign")}} now correctly returns a <code>PositionAlignSetting</code> enum as per spec; previously it returned an <code>AlignSetting</code> enum ({{bug(1276129)}}).</li>
 <li>The Speech Synthesis part of the Web Speech API is now enabled by default across all desktop browsers ({{bug(1268633)}}).</li>
 <li>The {{domxref("Animation.Animation()", "Animation()")}} constructor of the <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a> now accepts a null timeline ({{bug(1096776)}}).</li>
 <li>The {{domxref("KeyframeEffect")}} property {{domxref("KeyframeEffect.target", "target")}} is now supported in Firefox, if you have enabled <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations</a> ({{bug(1067769)}}).</li>
</ul>

<h3 id="MathML">MathML</h3>

<p><em>No change.</em></p>

<h3 id="SVG">SVG</h3>

<ul>
 <li>Removed support for the deprecated {{SVGElement('altGlyph')}}, {{SVGElement('altGlyphDef')}} and {{SVGElement('altGlyphItem')}} elements ({{bug(1260032)}}).</li>
</ul>

<h3 id="AudioVideo">Audio/Video</h3>

<p><em>No change.</em></p>

<h3 id="Plugins_and_Flash">Plugins and Flash</h3>

<p>Beginning in Firefox 49, Firefox, by default, blocks certain kinds of Flash content that aren't necessary for sites to function well. This behavior, controlled by the preference <code>browser.safebrowsing.blockedURIs.enabled</code>, helps to improve the performance of sites and Firefox in general without having significant impact on site usability. It also helps improve stability of the browsing experience by elminating a major cause of crashes. The blocked Flash modules include several used just for fingerprinting purposes, as well as a number of "supercookie" modules, and in the future may be expanded to include more types of blocked modules. See {{bug(1275591)}} for details.</p>

<p>This marks the next step in the journey toward a plugin-free future. HTML is very close to the point where plugins will no longer be needed to get the job done.</p>

<h2 id="HTTP">HTTP</h2>

<ul>
 <li>The <code><a href="/en-US/docs/Web/HTTP/Headers/Cache-Control">Cache-Control: immutable</a></code> directive has been implemented ({{bug(1267474)}}). See also this <a href="https://bitsup.blogspot.de/2016/05/cache-control-immutable.html">blog post</a> for more information.</li>
 <li>The {{CSP("require-sri-for")}} {{HTTPHeader("Content-Security-Policy")}} has been implemented ({{bug(1265318)}}).</li>
</ul>

<h2 id="Networking">Networking</h2>

<ul>
 <li>The <a href="/en-US/docs/Mozilla/Projects/Necko/Proxy_Auto-Configuration_(PAC)_file">Proxy Auto-Configuration (PAC)</a> implementation has been updated. Now <code>weekdayRange</code>, <code>dateRange</code>, and <code>timeRange</code> support "reversed ranges", for example, <code>weekdayRange("SAT", "MON")</code> will evaluate <code>true</code> if the current day is Saturday, Sunday, or Monday ({{bug(1251332)}}).</li>
</ul>

<h2 id="Security">Security</h2>

<ul>
 <li>The {{domxref("Window.isSecureContext")}} property, indicating whether a context is capable of using features that require <a href="/en-US/docs/Web/Security/Secure_Contexts">secure contexts</a>, has been implemented ({{bug(1162772)}}).</li>
</ul>

<h2 id="Compatibility">Compatibility</h2>

<p>In order to improve compatibility with existing content, Firefox now accepts some webkit prefixed properties and attributes.</p>

<ul>
 <li>    The following properties now also work prefixed with <code>-webkit</code>:

  <ul>
   <li>{{cssxref("-webkit-align-items")}}</li>
   <li>{{cssxref("-webkit-align-content")}}</li>
   <li>{{cssxref("-webkit-align-self")}}</li>
   <li>{{cssxref("-webkit-animation")}}</li>
   <li>{{cssxref("-webkit-animation-delay")}}</li>
   <li>{{cssxref("-webkit-animation-direction")}}</li>
   <li>{{cssxref("-webkit-animation-duration")}}</li>
   <li>{{cssxref("-webkit-animation-fill-mode")}}</li>
   <li>{{cssxref("-webkit-animation-iteration-count")}}</li>
   <li>{{cssxref("-webkit-animation-name")}}</li>
   <li>{{cssxref("-webkit-animation-play-state")}}</li>
   <li>{{cssxref("-webkit-animation-timing-function")}}</li>
   <li>{{cssxref("-webkit-backface-visibility")}}</li>
   <li>{{cssxref("-webkit-background-clip")}}</li>
   <li>{{cssxref("-webkit-background-origin")}}</li>
   <li>{{cssxref("-webkit-background-size")}}</li>
   <li>{{cssxref("-webkit-border-bottom-left-radius")}}</li>
   <li>{{cssxref("-webkit-border-bottom-right-radius")}}</li>
   <li>{{cssxref("-webkit-border-image")}}</li>
   <li>{{cssxref("-webkit-border-top-left-radius")}}</li>
   <li>{{cssxref("-webkit-border-top-right-radius")}}</li>
   <li>{{cssxref("-webkit-border-radius")}}</li>
   <li>{{cssxref("-webkit-box-shadow")}}</li>
   <li>{{cssxref("-webkit-filter")}}</li>
   <li>{{cssxref("-webkit-flex")}}</li>
   <li>{{cssxref("-webkit-flex-basis")}}</li>
   <li>{{cssxref("-webkit-flex-direction")}}</li>
   <li>{{cssxref("-webkit-flex-flow")}}</li>
   <li>{{cssxref("-webkit-flex-grow")}}</li>
   <li>{{cssxref("-webkit-flex-shrink")}}</li>
   <li>{{cssxref("-webkit-flex-wrap")}}</li>
   <li>{{cssxref("-webkit-justify-content")}}</li>
   <li>{{cssxref("-webkit-order")}}</li>
   <li>{{cssxref("-webkit-perspective")}}</li>
   <li>{{cssxref("-webkit-perspective-origin")}}</li>
   <li>{{cssxref("-webkit-text-size-adjust")}}</li>
   <li>{{cssxref("-webkit-transform")}}</li>
   <li>{{cssxref("-webkit-transform-origin")}}</li>
   <li>{{cssxref("-webkit-transform-style")}}</li>
   <li>{{cssxref("-webkit-transition")}}</li>
   <li>{{cssxref("-webkit-transition-delay")}}</li>
   <li>{{cssxref("-webkit-transition-duration")}}</li>
   <li>{{cssxref("-webkit-transition-property")}}</li>
   <li>{{cssxref("-webkit-transition-timing-function")}}</li>
   <li>{{cssxref("-webkit-user-select")}}</li>
  </ul>
 </li>
 <li>The following properties map to the equivalent prefixed property:
  <ul>
   <li>{{cssxref("-webkit-box-flex")}}</li>
   <li>{{cssxref("-webkit-box-ordinal-group")}}</li>
   <li>{{cssxref("-webkit-box-orient")}}</li>
   <li>{{cssxref("-webkit-box-align")}}</li>
   <li>{{cssxref("-webkit-box-pack")}}</li>
  </ul>
 </li>
 <li>For {{cssxref("&lt;image&gt;")}} values:
  <ul>
   <li>The following functions map to their unprefixed equivalents: {{cssxref("-webkit-linear-gradient", "-webkit-linear-gradient()")}}, {{cssxref("-webkit-radial-gradient", "-webkit-radial-gradient()")}}, {{cssxref("-webkit-repeating-linear-gradient", "-webkit-repeating-linear-gradient()")}}, and {{cssxref("-webkit-repeating-radial-gradient","-webkit-repeating-radial-gradient()")}}.</li>
   <li>The outdated <code>-webkit-gradient</code> is supported (and translated to a regular gradient)</li>
  </ul>
 </li>
 <li>The following {{cssxref("display")}} values are translated:
  <ul>
   <li><code>-webkit-box</code> to <code>-moz-box</code></li>
   <li><code>-webkit-flex</code> to <code>flex</code></li>
   <li><code>-webkit-inline-box</code> to <code>inline-flex</code></li>
   <li><code>-webkit-inline-flex</code> to <code>-moz-inline-flex</code></li>
  </ul>
 </li>
 <li> The following properties are supported (and don't map to any unprefixed equivalent):
  <ul>
   <li>{{cssxref("-webkit-text-fill-color")}}</li>
   <li>{{cssxref("-webkit-text-stroke-color")}}</li>
   <li>{{cssxref("-webkit-text-stroke-width")}}</li>
   <li>{{cssxref("-webkit-text-stroke")}}</li>
  </ul>
 </li>
 <li>The {{domxref("WebKitCSSMatrix")}} interface is an alias of {{domxref("DOMMatrix")}}</li>
 <li>The following media query features have been implemented:
  <ul>
   <li><code>-webkit-min-device-pixel-ratio</code> as an alias of <code><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#resolution">min-resolution</a></code> with the same value (in <code>dppx)</code>, though this feature is <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1237720">disabled by default</a> (behind about:config pref <code>layout.css.prefixes.device-pixel-ratio-webkit</code>)</li>
   <li><code>-webkit-max-device-pixel-ratio</code> as an alias of <code><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#resolution">max-resolution</a></code> of the same value (in <code>dppx</code>); this feature is also disabled by default, behind the same about:config pref.</li>
   <li><code><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#-webkit-transform-3d">-webkit-transform-3d</a></code> always matching, indicating 3d transform support.</li>
  </ul>
 </li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<ul>
 <li>Support for the {{WebExtAPIRef("history")}} has been added. This provides access to the browser history, with methods available for searching the history, getting information about previously-visited pages, and adding and removing history entries.</li>
 <li>Added the {{WebExtAPIRef("tabs.removeCSS()")}} method to the tabs API. This method lets you remove CSS which was previously injected by calling {{WebExtAPIRef("tabs.insertCSS()")}}.</li>
</ul>

<h3 id="Interfaces">Interfaces</h3>

<ul>
 <li>In {{domxref("EventTarget.addEventListener()")}}, the value <code>mozSystemGroup</code>,  active only in code running in XBL or in Firefox's chrome, is a {{jsxref("Boolean")}} which indicates if the listener is added to the system group. ({{bug(1274520)}})</li>
</ul>

<h3 id="Other">Other</h3>

<p><em>No change.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/49">Site Compatibility for Firefox 49</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(48)}}</p>
